<?php


namespace phpboom\services;

/**
 * Pomocná třída - vhodná pro jednodušší projekty
 * Je to vlastně takový kontejner pro naše služby (jiné objekty), které si ukládá v jedné kopii 
 * a poskytuje je vždy, když si o ně někdo (nějaký objekt) zažádá
 * Např. Mailer, Databáze, Request, Response atd.
 */
class Register {
    
    /** Jmenny prostor tříd služeb */
    const SERVICES_NS = "phpboom\\services\\";
    
    
    private $services = [];
    
    
    /**
     * Vraci registrovanou službu dle jejiho oznaceni
     * @param string $key
     * @return object
     */
    public function getService($key) 
    {
        $class = self::SERVICES_NS . \ucfirst($key);
        if (!\array_key_exists($class, $this->services)) {
            // Toto misto je citlive na chyby
            // Uměli byste jej ošetřit zachycením vyjímky?
            // Jak ošetřit vyjímku: https://www.w3schools.com/php/php_exception.asp
            $this->services[$key] = new $class;
        }
        return $this->services[$key];
    }
}
